<!DOCTYPE html>
<html lang="en-US">
<head>
	<title>Local Weather App</title>

	<meta charset="utf-8">

	<!-- Force latest available IE rendering engine and Chrome Frame (if installed) -->
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">

	<!-- Mobile Screen Resizing -->
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.1/normalize.min.css">
	<link href="https://fonts.googleapis.com/css?family=Cutive|Work+Sans" rel="stylesheet">


	<style type="text/css">
		/**
		 * Add box sizing to everything
		 * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
		 */
		*,
		*:before,
		*:after {
			box-sizing: border-box;
		}

		/**
		 * Layout
		 */
		body {
			font-family: 'Work Sans', sans-serif; sans-serif;
			margin-left: auto;
			margin-right: auto;
			max-width: 40em;
			width: 88%;
		}
		.flex-row {
			display: flex;
			align-items: center;
		}
		.flex-row div:first-child {
			padding-right: 2rem;
		}

		.text-center { text-align: center; }

	</style>
</head>
<body>
	<div id="app">Checking the weather near you...</div>

	<script crossorigin="anonymous" src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/dompurify/1.0.9/purify.min.js"></script>
	<script>

		const LocalWeather = (function () {

			'use strict';

			/**
			 * Setup Constructor
			 */

			let Constructor = function () {

				//
				// Variables
				//

				let publicAPIs = {};

				let settings, selector, local;

				/**
				 * To Do List:
				 * Auto Update location with getIPAddress() method
				 * Forecast Type options
				 * Units °F or °C [settting]
				 * Chance of rain? [setting?]
				 */

				let defaults = {
					apiKey: '0380780429f84d9db13057d8a5a6925b',
					forecast: 'current',
					postalCode: '',
					units: 'I',
					target: '#app'
				};


				const getData = function (url, callback) {
					let xhr = new XMLHttpRequest();
					xhr.onreadystatechange = function () {
						if (xhr.readyState !== 4 ) return;

						if (xhr.status >= 200 && xhr.status < 300 ) {
							callback(JSON.parse(xhr.responseText))
						}
					}

					xhr.open('GET', url);
					xhr.send();
				}

				/**
				 * Gets weather data and injects it into the DOM
				 * @param  {[type]} selector [description]
				 * @param  {[type]} location [description]
				 * @return {[type]}          [description]
				 */
				const getWeather = function (selector, location) {
					// set url
					let url = 'https://api.weatherbit.io/v2.0/'+ settings.forecast +'?units='+ settings.units +'&postal_code='+ location +'&key='+ settings.apiKey
					// get data
					getData(url, function (data) {

						let html = [];
						let results = data.data[0]

						// Create checks for 5 and 10 day forcasts
						html.push(`
							<div>
								<h2> Weather for ${results.city_name}, ${results.state_code} ${results.country_code}</h2>
								<h3>${results.weather.description}</h3>
								<div class="flex-row">
									<div>
										<img src="https://www.weatherbit.io/static/img/icons/${results.weather.icon}.png" />
									</div>
									<div>
										<p>Temp ${results.temp}&deg;F</p>
										<p>Feels like ${results.app_temp}&deg;F</p>
										<p>Cloud coverage ${results.clouds}%</p>
										<p>Sunrise ${results.sunrise}</p>
										<p>Sunset ${results.sunset}</p>
									</div>
								</div>
							</div>
							`)
						selector.innerHTML = DOMPurify.sanitize(html.join(''))
					})
				}

				/**
				 * Gets the local weather
				 * @return {[type]} [description]
				 */
				const getLocalWeather = function () {
					getData('https://ipapi.co/json', function (data) {
						// Get the weather data then pass the postal code in
						getWeather(selector, data.postal)
					})
				}

				/**
				 * Initializes public methods
				 * @param  {[type]} options [description]
				 * @return {[type]}         [description]
				 */

				publicAPIs.init = function (options) {

					// Merge user options into defaults
					settings = Object.assign({}, defaults, options);

					selector = document.querySelector(settings.target);

					getLocalWeather()
				}

				//
				// Return Public Methods
				//

				return publicAPIs;

			}

			//
			// Return Constructor
			//

			return Constructor;
		})();

		const app = new LocalWeather()
		app.init()

	</script>

</body>
</html>
